list P=16F84A
INCLUDE <P16F84A.INC>
__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_OFF & _HS_OSC
CBLOCK 0Ch
W_T01
W_TC1
W_TC2
W_TC3
W_TC4
W_TC5
W_TC7
W_T50
SENSOR
SENLMR
MOT
LMR
ENDC

MAIN	BCF	INTCON, GIE
	CLRF	PORTA
	CLRF	PORTB
	BSF	STATUS, RP0
	MOVLW	B'11110000'	;inputport PA 4--- outputport PA 0123 
	MOVWF	TRISA
	MOVLW	B'10001111'	;inputport PB 01237 outputport PB 456
	MOVWF	TRISB
	BCF	STATUS, RP0
	MOVLW	00h   	;Stop the Motor 
	MOVWF	PORTA
	CLRF	SENSOR
        CLRF	SENLMR
	CLRF	MOT
	CLRF	LMR
SW1	CALL	SENS
	BTFSC	PORTA,4
	GOTO	SW1
SW2	BTFSS	PORTA,4
 	GOTO	SW2
	CALL	WAT50
ST1	CALL 	FWRD
	CALL	SSTP	;1
      	CALL	SSTP	;2
ST2	CALL	SENS    ;PB2 PB1 PB0   
	MOVF	SENSOR,W	;	ACC PCL+F
	ADDWF	PCL,F   ;PB 2  1  0	PA 2  1  0
	GOTO	BACK	;   1  1  1        0  0  0
	GOTO	TRNR	;   1  1  0	   0  0  1
	GOTO	ST1	;   1  0  1	   0  1  0
	GOTO	TRSR	;   1  0  0	   0  1  1
	GOTO	TRNL	;   0  1  1	   1  0  0
	GOTO	ST1	;   0  1  0	   1  0  1
	GOTO	TRSL	;   0  0  1	   1  1  0
	GOTO	ST1	;   0  0  0	   1  1  1
TRNR			;Turn to the Right
			;    8  4  2  1
	MOVLW	0Ah	;PA  3  2  1  0
	MOVWF	PORTA	;PA  1  0  1  0
	CALL	WAIT7	;Wait 7msec
	CALL	STPR	;1
	GOTO	ST1	;
TRSR			;Turn to the Right
	MOVLW	0Ah	;PA  3  2  1  0
	MOVWF	PORTA	;PA  1  0  1  0
	CALL	WAIT3	;Wait 3msec
	CALL	STPR	;1
	GOTO	ST1	;
TRNL			;Turn to the Left
	MOVLW	09h	;PA  3  2  1  0
      	MOVWF	PORTA	;PA  1  0  0  1
      	CALL	WAIT7	;Wait 7msec
	CALL	STPL	;1
      	GOTO	ST1	;
TRSL			;Turn to the Left
	MOVLW	09h	;PA  3  2  1  0
      	MOVWF	PORTA	;PA  1  0  0  1
      	CALL	WAIT3	;Wait 3msec
	CALL	STPL	;1
      	GOTO	ST1
BACK	MOVLW	07h	;PA  3  2  1  0
	MOVWF	PORTA	;PA  0  1  1  1
	CALL	WAIT1	;Wait 1msec
	CALL	SSTP	;1
	CALL	SSTP	;2
	GOTO	ST2
FWRD	MOVLW	0Bh	;PA  3  2  1  0
	MOVWF	PORTA	;PA  1  0  1  1  short @for the actuator
	CALL	WAIT1	;Wait 1msec
	RETURN
SENS	MOVF	PORTB,W
	MOVWF	LMR
	MOVWF	SENSOR
	COMF	SENSOR,W
	MOVWF	SENLMR
	COMF	SENLMR,W
	RLF	SENLMR
	RLF	SENLMR
      	RLF	SENLMR
      	RLF	SENLMR
	MOVF	SENLMR,W
   	MOVWF	PORTB
	MOVF	SENSOR,W
	ANDLW	07h
	MOVWF	SENSOR
   	RETURN
SSTP	MOVLW	03h	;PA  3  2  1  0
	MOVWF	PORTA	;PA  0  0  1  1  short  for the actuator
	CALL	WAIT1	;Wait 1msec
	RETURN	
STPR	;Turn to the Right
			;    8  4  2  1
	MOVLW	02h	;PA  3  2  1  0
	MOVWF	PORTA	;PA  0  0  1  0
	CALL	WAIT1	;Wait 1msec
	RETURN	
STPL	;Turn to the Left
	MOVLW	01h	;PA  3  2  1  0
      	MOVWF	PORTA	;PA  0  0  0  1
	CALL	WAIT1	;Wait 1msec
	RETURN	
WAT01	MOVLW	D'165'	;100usec with 20MHz CPU Clk
	MOVWF	W_T01
	DECFSZ	W_T01,F
 	GOTO	$-1
	RETURN
WAIT1	MOVLW	D'10'	;1msec
	MOVWF	W_TC1
	CALL	WAT01
	DECFSZ	W_TC1,F
	GOTO	$-2
	RETURN
WAIT2	MOVLW	D'20'	;2msec
	MOVWF	W_TC2
	CALL	WAT01
	DECFSZ	W_TC2,F
	GOTO	$-2
	RETURN
WAIT3	MOVLW	D'30'	;3msec
	MOVWF	W_TC3
	CALL	WAT01
	DECFSZ	W_TC3,F
	GOTO	$-2
	RETURN
WAIT4	MOVLW	D'40'	;4msec
	MOVWF	W_TC4
	CALL	WAT01
	DECFSZ	W_TC4,F
	GOTO	$-2
	RETURN
WAIT5	MOVLW	D'50'	;5msec
	MOVWF	W_TC5
	CALL	WAT01
	DECFSZ	W_TC5,F
	GOTO	$-2
	RETURN
WAIT7	MOVLW	D'70'	;7msec
	MOVWF	W_TC7
	CALL	WAT01
	DECFSZ	W_TC7,F
	GOTO	$-2
	RETURN
WAT50	MOVLW	D'100'	;0.5sec
	MOVWF	W_T50
	CALL	WAIT5
	DECFSZ	W_T50,F
	GOTO	$-2
	RETURN
STOP	MOVLW	00h
	MOVWF	PORTA
	GOTO	STOP
INT;荞ݖgp
	RETFEIE
END

